with Ada.Float_Text_IO;use Ada.Float_Text_IO;
with Ada.Text_Io; use Ada.Text_Io;
with Llegir_Fitxer;
with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;
with dades;use dades;
with Tad_Llista;--importem les llistes dinamiques
with Random;-- tad per fer random
 
procedure Xarxescomplexes is

      TYPE resultat IS RECORD
         Rang:integer:=0;
         Id:integer;
         mis_origen:integer:=0;
         mis_intermediari:integer:=0;
         mis_desti:integer:=0;
      END RECORD;

      type Taula_Rec is array (Positive range<>) of integer;
      type Tr is access Taula_Rec;
      
      type Taula_Resultats is array (Positive range<>) of resultat;
      type TRes is access Taula_resultats;
      Llista_resultats:Tres;

      TYPE missatge IS RECORD
         info : String(1..20);
         font : Positive;
         Desti : Positive;
         Origen:Boolean:=False;
         Rec:Tr;
         dist_max:integer:=0;
      END RECORD;
      --instanciacio tad_llista
      procedure copiar_missatge(E1: in missatge; E2: out missatge) is
      begin
         E2.info:=E1.info;
         E2.font:=E1.font;
         E2.Desti:=E1.Desti;
         E2.Rec:=E1.Rec;
         E2.Dist_Max:=E1.Dist_Max;
         E2.origen:=E1.origen;
      end copiar_missatge;
 
      package Llista_Missatge is new Tad_Llista (Missatge, Copiar_Missatge);use Llista_Missatge; 
 
      taula_generats:Llista;
      Num_Nodes,Num_Missatges,Protocol,distancia_maxima,k,ci:Integer;   --,mis_circulant,mis_rebuts
      Mis:Missatge;
      Ruta : String(1..30);
      C:Character;
      pp:boolean:=false;
      
      dades:resultats;
      --Declaracio de una llista dinamica amb apuntadors
      type Tt is array(Positive range <>,Positive range<>) of Integer;
      type Ptt is access Tt;
      Matriu: Ptt;
     

 procedure set_mat(e1: in out Ptt;e2:in Integer;e3:in Integer; e4: in Integer) is
      begin
         e1(e2,e3):=e4;
      end Set_Mat;
      
      package Llf is new llegir_Fitxer (Ptt, set_mat);use Llf;

     -------------------------------------------------------------------------------
  procedure Crear_Fitxer(resultats: in Tres) is
    F:File_Type;
  begin
     Create (F,Out_File,"resultats.txt");
      Put(f,"         RANG");Put(f,"       IDENT");Put(f,"     MIS ORIGEN");Put(f,"    MIS INTERMEDIARI");Put(f,"    MIS DESTI");New_Line(F);
      for i in 1..num_nodes loop       
       Put(f,resultats(i).Rang);Put(f,resultats(i).Id);Put(f,resultats(i).Mis_Origen);
       Put(f,"       ");Put(f,resultats(i).mis_intermediari);Put(f,"      ");Put(f,resultats(i).mis_desti); New_line(F);      
      end loop;
     Close(F);
  end crear_fitxer;
  -----------------------------------------------------------------------------

---------------------------------------- node .adb.ads -----------------------------------------       
       task type node (Id: Integer;Matriz:Ptt;Protocol: Integer;Num_n:integer) is
          entry Rep(E: in Missatge);
       end Node;
      
       -- Declaracio de la llista dinamica de threads
       type Pt is access Node;--definim un apuntador a T
       type Pi is array (Positive range<>) of Pt;-- Taula de nodes 
       type Pix is access Pi;
       P: Pix;  

       procedure Repp (B:in out llista;E: in missatge) is-- envia un missatge
       begin
          insertar(b,E);
       end Repp;

       procedure intercanvi(x:in out resultat; y:in out resultat) is 
          aux:resultat;
       begin
          aux:=x;
          x:=y;
          y:=aux;
       end intercanvi;

       task body Node is
         m_cir,m_reb:integer;
         Bustia:Llista;
         Z,I:Integer:=1;
         Trobat,b:Boolean;
         c:character;
         type taula_Veins is array (1..Num_N) of Integer;
         Veins:Taula_Veins;
         Alea:Positive;
         Vei_Mes_Rang,Contador,Max,pmax:Integer;
         Dist_Mitj_Ant:Integer:=0;
         Dist_Mitj:float:=0.0;
         mis_origen,mis_desti,mis_inter:integer:=0;
         type M is access Missatge;
         E:missatge;
         begin
         ------------------------------------------------------------
         --Plenem llista de veins de -1   
         Crear_Llista(Bustia);
         for i in 1..Num_n loop
            veins(i):=-1;
         end loop;
         ------------------------------------------------------------
         --Plenem la llista de veins 
         for I in 1..Num_N loop
            if (Matriz(Id,I)=1) then
               Veins(z):=I;
               z:=z+1;
            end if;    
         end loop;
         Z:=Z-1;-- pk al final del loop sera un de mes
         ------------------------------------------------------------
         Llista_Resultats(Id).Rang:=0;
         -- Busquem el rang del node
         for J in 1..Num_N loop
            if (Matriz(Id,J)=1) then
               Llista_resultats(id).rang:=Llista_resultats(id).rang+1;
            end if; 
         end loop;
         ------------------------------------------------------------
         --Busquem el vei de mes rang
         Vei_Mes_Rang:=0;
         max:=0;
         contador:=0;
         for I in 1..Num_N loop
            if (Veins(I)/=-1) then
               for J in 1..Num_N loop
                  if (Matriz(Veins(I),J)=1) then
                     Contador:=Contador+1;
                  end if;
               end loop;
               if (Max<Contador) then
                  max:=contador;
                  vei_mes_rang:=veins(I);
               end if;
            end if;
         end loop;
         ------------------------------------------------------------
         Llista_Resultats(Id).Id:=Id;
         Get_Mis_Rebuts(Dades,M_reb);               
         ------------------------------------------------------------   
         while (M_Reb/=Num_Missatges) loop
           Get_Mis_Rebuts(Dades,M_reb); 
           select
               --when 1 < 3 =>-- aqui hauriem de ficar mentres quedin missatges circulant crec
               accept Rep(E: in Missatge) do
                     repp(bustia,e);
               end Rep;
            else
            if (Buida(Bustia)=False) then
          -----------------------------------------RANDOM----------------------------------------------------
              if Protocol=1 then
                 principi(bustia);
                 Consulta(Bustia,E);
                 Esborrar(Bustia);  
                 if (e.font=id and e.origen=false) then
                     Mis_Origen:=Mis_Origen+1;                 
                     E.Origen:=True; 
                     Llista_Resultats(Id).mis_origen:=mis_origen;                                         
                 end if;
                  
                 if (Id/=E.Desti) then 
                    E.dist_max:=E.dist_max+1;                   
                    alea:=Random.Positive_Random (Maximo => Z);                          
                    P(Veins(Alea)).Rep(E);      
                    Mis_Inter:=Mis_Inter+1;
                    Llista_Resultats(Id).mis_intermediari:=mis_inter;                
                    --Put("THREAD ");Put(Id);Put("   ENVIA MISSATGE A  "); Put(Veins(Alea));new_line;
                 else
                             
                   Get_Distancia_Maxima(Dades,Distancia_Maxima);        
                   if (E.Dist_Max>Distancia_Maxima) then    
                      Set_Distancia_Maxima(Dades,e.dist_max);
                   end if;                           
                   Get_Mis_Circulant(dades,m_cir);
                   m_cir:=m_cir-1;
                   Set_Mis_Circulant(dades,m_cir);
                   Get_Mis_Rebuts(dades,m_reb);
                   m_reb:=m_reb+1;
                   Set_Mis_Rebuts(Dades,M_Reb);        
                   Get_Distancia_Mitjana_Ant(Dades,Dist_Mitj_Ant);                                                                    
                   Dist_Mitj_Ant:=Dist_Mitj_Ant+E.Dist_Max;
                   Set_Distancia_Mitjana_Ant(Dades,Dist_Mitj_Ant);         
                   Dist_Mitj:= float(Dist_Mitj_Ant)/ float(M_Reb);
                   Set_Distancia_Mitjana(Dades,Dist_Mitj); 
                   Mis_Desti:=Mis_Desti+1;
                   Llista_Resultats(Id).mis_desti:=mis_desti;                        
                   Put("REP UN MISSATGE PER A ELL");Put(Id);New_Line;                            
                 end if;
                  if (M_Reb=Num_Missatges) then
                    New_Line(20);  
                    Put("   ---------------------------------------------------------");     New_Line;                        
                    Put("   -------------- RESULTATS DE LA SIMULACIO-----------------");    New_Line;  
                    Put("   ---------------------------------------------------------");    New_Line(2);    
                    PUT("     NUMERO DE MISSATGES GENERATS :         "); PUT(num_missatges); New_Line(2);
                    PUT("     NUMERO DE MISSATGES CIRCULANT :        "); PUT(m_cir); New_Line(2);       
                    Put("     NUMERO DE MISSATGES REBUTS :           "); Put(M_Reb); New_Line(2);
                    Get_Distancia_Maxima(Dades,Distancia_Maxima);
                    Put("     DISTANCIA MAXIMA :                     "); Put(Distancia_Maxima); New_Line(2);  
                    Get_Distancia_Mitjana(Dades,Dist_mitj);
                    Put("     DISTANCIA MITJANA :                        "); Put (Item => Dist_Mitj, Aft  => 2, Exp  => 0); New_Line(8);
                    --C:='a';
                    Put("  PREM UNA TECLA I PREM ENTER PER A MOSTRAR ELS RESULTATS INDIVIDUALS DE CADA NODE .... ");Get(C); 
                    New_Line(20);  
                    Put("        -----------------------------------------------------------------");     New_Line;                        
                    Put("        ------------ RESULTATS INDIVIDUALS DE LA SIMULACIO --------------");    New_Line;  
                    Put("        -----------------------------------------------------------------");    New_Line(2);    
                    -- Ordenacio per seleccio directa de la taula de resultats en funcio del rang
                    for i in 1..num_nodes loop
                       pmax:=i;
                       for j in i+1..num_nodes loop
                          if (Llista_resultats(j).rang>Llista_resultats(pmax).rang) then                    
                             pmax:=j;
                          end if;
                       end loop;
                       intercanvi(Llista_resultats(i),Llista_resultats(pmax));
                    end loop; 
                    Put("         RANG");Put("     IDENT.");Put("     MIS ORIGEN");Put("    MIS INTERMEDIARI");Put("    MIS DESTI");New_Line(2);
                    for i in 1..num_nodes loop       
                       Put(Llista_Resultats(i).Rang);Put(Llista_Resultats(i).Id);Put(Llista_Resultats(i).Mis_Origen);
                       Put("       ");Put(Llista_Resultats(i).mis_intermediari);Put("      ");Put(Llista_Resultats(i).mis_desti); New_line;      
                    end loop;
                    New_Line(5);
                    --C:='c';
                    Put("PREM UNA TECLA I PREM ENTER PER A FINALITZAR EL PROGRAMA I CREAR L'ARXIU AMB ELS RESULTATS ");Get(c);        
                  Crear_Fitxer(Llista_Resultats) ; 
                  end if;             
          -----------------------------------------INTELIGENT------------------------------------------------
          -- SI ES DESTI = ID REP EL MISSATGE I ESBORRA
              elsif Protocol=2 then
                    principi(bustia);
                    Consulta(Bustia,E);
                    Esborrar(Bustia);  
                    Trobat:=False;
                    b:=false; 
                 if (e.font=id and e.origen=false) then
                     Mis_Origen:=Mis_Origen+1;                 
                     E.Origen:=True; 
                     b:=true;      
                     Llista_Resultats(Id).mis_origen:=mis_origen;                                         
                 end if;                  
                 if (Id=E.Desti) then 
                    Get_Distancia_Maxima(Dades,Distancia_Maxima);        
                    if (E.Dist_Max>Distancia_Maxima) then    
                       Set_Distancia_Maxima(Dades,e.dist_max);
                    end if;                           
                    Get_Mis_Circulant(dades,m_cir);
                    m_cir:=m_cir-1;
                    Set_Mis_Circulant(dades,m_cir);
                    Get_Mis_Rebuts(dades,m_reb);
                    m_reb:=m_reb+1;
                    Set_Mis_Rebuts(Dades,M_Reb);        
                    Get_Distancia_Mitjana_Ant(Dades,Dist_Mitj_Ant);                                                                    
                    Dist_Mitj_Ant:=Dist_Mitj_Ant+E.Dist_Max;
                    Set_Distancia_Mitjana_Ant(Dades,Dist_Mitj_Ant);         
                    Dist_Mitj:= float(Dist_Mitj_Ant)/ float(M_Reb);
                    Set_Distancia_Mitjana(Dades,Dist_Mitj); 
                    Mis_Desti:=Mis_Desti+1;
                    Llista_Resultats(Id).mis_desti:=mis_desti;
                    Put("REP UN MISSATGE PER A ELL");Put(Id);New_Line; 
                    trobat:=true;        
                 end if;
                 -- SI UN DELS VEINS ES EL DESTI ENVIALI
                 I:=1;
                 while (i<=z and trobat = false) loop --num_n
                    if (Veins(I)=E.Desti) then
                       E.dist_max:=E.dist_max+1;       
                       P(Veins(I)).Rep(E);       
                       --Put("THREAD1 ");Put(Id);Put("   ENVIA MISSATGE A  "); Put(Veins(i));New_Line;
                       trobat:=true;
                       if (b = false and trobat=true) then
                          Mis_Inter:=Mis_Inter+1;
                          Llista_Resultats(Id).mis_intermediari:=mis_inter;        
                       end if;
                    end if;
                    i:=i+1;
                 end loop;                         
                 -- SI VEI NO ES EL DESTI ENVIEM A NODE DE GRAU MES GRAN
                 if (Trobat=False and e.rec(vei_mes_rang)=1) then
                    E.dist_max:=E.dist_max+1;
                    P(Vei_Mes_Rang).Rep(E);
                    E.Rec(Vei_Mes_Rang):=1;
                    if (b = false) then
                       Mis_Inter:=Mis_Inter+1;
                       Llista_Resultats(Id).mis_intermediari:=mis_inter;
                    end if;
                    Trobat:=True;
                    --Put("THREAD2 ");Put(Id);Put("   ENVIA MISSATGE A  "); Put(Veins(vei_mes_rang));New_Line;                           
                 end if;
                 -- SI JA EM PASAT PEL NODE DE GRAU MES GRAN FEM RANDOM PER EVITAR BUCLES INFINITS
                 if (trobat=false) then
                    alea:=Random.Positive_Random (Maximo => Z);                          
                    E.dist_max:=E.dist_max+1;
                    P(Veins(Alea)).Rep(E);
                    if (b = false) then
                       Mis_Inter:=Mis_Inter+1;
                       Llista_Resultats(Id).mis_intermediari:=mis_inter;       
                    end if;
                    for J in 1..Num_N loop
                       E.Rec(J):=0;
                    end loop;
                    --Put("THREAD3 ");Put(Id);Put("   ENVIA MISSATGE A  "); Put(Veins(Alea));new_line;
                 end if;
                 if (M_Reb=Num_Missatges) then
                    New_Line(20);  
                    Put("   ---------------------------------------------------------");     New_Line;                        
                    Put("   -------------- RESULTATS DE LA SIMULACIO-----------------");    New_Line;  
                    Put("   ---------------------------------------------------------");    New_Line(2);    
                    PUT("     NUMERO DE MISSATGES GENERATS :         "); PUT(num_missatges); New_Line(2);
                    PUT("     NUMERO DE MISSATGES CIRCULANT :        "); PUT(m_cir); New_Line(2);       
                    Put("     NUMERO DE MISSATGES REBUTS :           "); Put(M_Reb); New_Line(2);
                    Get_Distancia_Maxima(Dades,Distancia_Maxima);
                    Put("     DISTANCIA MAXIMA :                     "); Put(Distancia_Maxima); New_Line(2);  
                    Get_Distancia_Mitjana(Dades,Dist_mitj);
                    Put("     DISTANCIA MITJANA :                          "); Put (Item => Dist_Mitj, Aft  => 2, Exp  => 0); New_Line(8);
                    --C:='a';
                    Put("  PREM UNA TECLA I PREM ENTER PER A MOSTRAR ELS RESULTATS INDIVIDUALS DE CADA NODE .... ");Get(C); 
                    New_Line(20);  
                    Put("        -----------------------------------------------------------------");     New_Line;                        
                    Put("        ------------ RESULTATS INDIVIDUALS DE LA SIMULACIO --------------");    New_Line;  
                    Put("        -----------------------------------------------------------------");    New_Line(2);    
                    -- Ordenacio per seleccio directa de la taula de resultats en funcio del rang
                    for i in 1..num_nodes loop
                       pmax:=i;
                       for j in i+1..num_nodes loop
                          if (Llista_resultats(j).rang>Llista_resultats(pmax).rang) then                    
                             pmax:=j;
                          end if;
                       end loop;
                       intercanvi(Llista_resultats(i),Llista_resultats(pmax));
                    end loop; 
                    Put("         RANG");Put("     IDENT.");Put("     MIS ORIGEN");Put("    MIS INTERMEDIARI");Put("    MIS DESTI");New_Line(2);
                    for i in 1..num_nodes loop       
                       Put(Llista_Resultats(i).Rang);Put(Llista_Resultats(i).Id);Put(Llista_Resultats(i).Mis_Origen);
                       Put("       ");Put(Llista_Resultats(i).mis_intermediari);Put("      ");Put(Llista_Resultats(i).mis_desti); New_line;      
                    end loop;
                    New_Line(5);
                    --C:=' ';
                    Put("PREM UNA TECLA I PREM ENTER PER A FINALITZAR EL PROGRAMA I CREAR L'ARXIU AMB ELS RESULTATS ");Get(c);        
                  Crear_Fitxer(Llista_Resultats) ; 
                  end if;            
              end if;
           end if;
        end select;
        deLAY(0.00000000001);
     end loop;
  end node;
----------------------------------------------------------------------------
  procedure Escriure_Matriu (Num_Nodes:in Integer;Matriu_Adjacencia: in Ptt) is
  begin
     New_Line;
     Put("LA MATRIU DE ADJACENCIA ES:");new_line;
     for J in 1..Num_Nodes loop
        for I in 1..Num_Nodes loop
           put(Matriu_Adjacencia(j,i));
        end loop;
        new_line;
     end loop;
  end Escriure_Matriu;
-----------------------------------------------------------------------------
begin  
   Put("        -----------------------------------------------------------------");    New_Line;                        
   Put("        ------------- PRACTICA DE XARXES COMPLEXES (ENS 2) --------------");    New_Line;  
   Put("        -----------------------------------------------------------------");    New_Line(2);    
   Put("             Numero de missatges a generar :            ");Get(Num_Missatges);New_Line(2);
   Put("             Protocol (1 randomwalk) (2 inteligent) :      ");Get(protocol);New_Line(2); 
   Put("             Ruta :      ");
   K:=1;
   ci:=0;
   for I in 1..30 loop
      Ruta(I):=' ';
   end loop;
   Get(C);
   while (pp=false and k<=30) loop 
      Ruta(K):=C;
      K:=K+1;
      Get(C);
      if (c='.') then
         Ci:=Ci+1;
      end if;
      if (c='n' and ci=1) then
         Ci:=Ci+1;
      end if;
      if (c='e' and ci=2) then
         Ci:=Ci+1;
      end if;
      if (ci=3 and c='t') then
         Ruta(K):=C;
         pp:=true;
      end if;
   end loop;
   New_Line(2);       
   Llegir_Num_Nodes(Num_Nodes,ruta);
   Matriu := new Tt(1..Num_Nodes,1..Num_Nodes);-- declaracio de la grandaria de la llista dinmica.
   inicialitzar_matriu(Num_Nodes,Matriu);
   Llegir(Num_Nodes,Matriu,ruta);
   Escriure_Matriu(Num_Nodes,Matriu);
   P := new Pi(1..Num_Nodes);-- Taula de nodes
   Llista_resultats:=new taula_resultats(1..num_nodes);  
   set_mis_circulant(dades,num_missatges);
   Set_Mis_Rebuts(dades,0);
   Set_Distancia_Maxima(dades,0);
   Set_Distancia_Mitjana(Dades,0.0);
   Set_Distancia_Mitjana_Ant(dades,0);
   declare
   begin
         -- generador de missatges
         Crear_Llista(Taula_Generats);
         for Id in 1..Num_Nodes loop
            P(Id):=new Node(Id,Matriu,Protocol,Num_Nodes);
         end loop;
         Mis.Info(1):='h';
         for S in 2..20 loop
            Mis.Info(S):=' ';
         end loop;
         -- inici generador de missatges
         new_line;
         PUt("GENERADOR DE MISSATGES");new_line;
         for I in 1..Num_Missatges loop 
            Mis.Rec:= new Taula_Rec(1..Num_Nodes);
            for J in 1..Num_Nodes loop
               Mis.Rec(J):=0;
            end loop;
            Mis.Font:= Random.Positive_Random (Maximo => Num_nodes);--Genera els nmeros de forma aleatoria
            Mis.Desti:= Random.Positive_Random (Maximo => Num_Nodes);--Genera els nmeros de forma aleatoria 
            insertar(taula_generats,Mis);
            Put(mis.font);put(" =>");put(mis.desti);new_line;
         end loop;
         principi(taula_generats);
         for I in 1..Num_Missatges loop
            Consulta(taula_generats,Mis);
            P(Mis.Font).Rep(Mis);
            avanar (taula_generats);
         end loop;
         -- fi generador de missatges         
   end;
     
end xarxescomplexes;
